Index: branches/HeuristicLab.Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Slave.Core/3.3/Core.cs
===================================================================
--- branches/HeuristicLab.Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Slave.Core/3.3/Core.cs	(revision 4987)
+++ branches/HeuristicLab.Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Slave.Core/3.3/Core.cs	(revision 5000)
@@ -364,4 +364,7 @@
         Logger.Info("Received new job with id " + e.Result.Obj.Id);
         Logger.Debug("Fetching plugins for job " + e.Result.Obj.Id);
+
+        String pluginDir = Path.Combine(PluginCache.Instance.PluginTempBaseDir, e.Result.Obj.Id.ToString());
+        bool pluginsPrepared = false;
         try {
           PluginCache.Instance.PreparePlugins(e.Result.Obj.PluginsNeeded.OrderBy(x => x.Name).ToList());
@@ -369,32 +372,39 @@
 
           Logger.Debug("Plugins fetched for job " + e.Result.Obj.Id);
-          String pluginDir = Path.Combine(PluginCache.Instance.PluginTempBaseDir, e.Result.Obj.Id.ToString());
-
-          AppDomain appDomain = HeuristicLab.PluginInfrastructure.Sandboxing.SandboxManager.CreateAndInitSandbox(pluginDir);
-          appDomain.UnhandledException += new UnhandledExceptionEventHandler(appDomain_UnhandledException);
-          lock (engines) {
-            if (!jobs.ContainsKey(e.Result.Obj.Id)) {
-              jobs.Add(e.Result.Obj.Id, e.Result.Obj);
-              appDomains.Add(e.Result.Obj.Id, appDomain);
-              Logger.Debug("Creating AppDomain");
-              Executor engine = (Executor)appDomain.CreateInstanceAndUnwrap(typeof(Executor).Assembly.GetName().Name, typeof(Executor).FullName);
-              Logger.Debug("Created AppDomain");
-              engine.JobId = e.Result.Obj.Id;
-              engine.Queue = MessageQueue.GetInstance();
-              Logger.Debug("Starting Engine for job " + e.Result.Obj.Id);
-              engines.Add(e.Result.Obj.Id, engine);
-              engine.Start(e.Data);
-              SlaveStatusInfo.JobsFetched++;
-              Logger.Info("Increment FetchedJobs to:" + SlaveStatusInfo.JobsFetched);
+          pluginsPrepared = true;
+        }
+        catch (Exception exception) {
+          Logger.Error(string.Format("Copying plugins for job {0} failed: {1}", e.Result.Obj.Id, exception));
+        }
+
+        if (pluginsPrepared) {
+          try {
+            AppDomain appDomain = HeuristicLab.PluginInfrastructure.Sandboxing.SandboxManager.CreateAndInitSandbox(e.Result.Obj.Id.ToString(), pluginDir, Path.Combine(pluginDir, PluginCache.ConfigFileName));
+            appDomain.UnhandledException += new UnhandledExceptionEventHandler(appDomain_UnhandledException);
+            lock (engines) {
+              if (!jobs.ContainsKey(e.Result.Obj.Id)) {
+                jobs.Add(e.Result.Obj.Id, e.Result.Obj);
+                appDomains.Add(e.Result.Obj.Id, appDomain);
+                Logger.Debug("Creating AppDomain");
+                Executor engine = (Executor)appDomain.CreateInstanceAndUnwrap(typeof(Executor).Assembly.GetName().Name, typeof(Executor).FullName);
+                Logger.Debug("Created AppDomain");
+                engine.JobId = e.Result.Obj.Id;
+                engine.Queue = MessageQueue.GetInstance();
+                Logger.Debug("Starting Engine for job " + e.Result.Obj.Id);
+                engines.Add(e.Result.Obj.Id, engine);
+                engine.Start(e.Data);
+                SlaveStatusInfo.JobsFetched++;
+                Logger.Info("Increment FetchedJobs to:" + SlaveStatusInfo.JobsFetched);
+              }
             }
+            heartbeatManager.AwakeHeartBeatThread();
           }
-          heartbeatManager.AwakeHeartBeatThread();
-        }
-        catch (Exception exception) {
-          Logger.Error("Creating the Appdomain and loading the job failed for job " + e.Result.Obj.Id);
-          Logger.Error("Error thrown is: ", exception);
-          CurrentlyFetching = false;
-          KillAppDomain(e.Result.Obj.Id);
-          wcfService.StoreFinishedJobResultsSync(ConfigManager.Instance.GetClientInfo().Id, e.Result.Obj.Id, new byte[] { }, e.Result.Obj.ExecutionTime, exception.ToString(), true);
+          catch (Exception exception) {
+            Logger.Error("Creating the Appdomain and loading the job failed for job " + e.Result.Obj.Id);
+            Logger.Error("Error thrown is: ", exception);
+            CurrentlyFetching = false;
+            KillAppDomain(e.Result.Obj.Id);
+            wcfService.StoreFinishedJobResultsSync(ConfigManager.Instance.GetClientInfo().Id, e.Result.Obj.Id, new byte[] { }, e.Result.Obj.ExecutionTime, exception.ToString(), false);
+          }
         }
       } else {
@@ -411,5 +421,4 @@
     void wcfService_StoreFinishedJobResultCompleted(object sender, StoreFinishedJobResultCompletedEventArgs e) {
       Logger.Info("Job submitted with id " + e.Result.JobId);
-      KillAppDomain(e.Result.JobId);
       if (e.Result.StatusMessage == ResponseStatus.Ok) {
         SlaveStatusInfo.JobsProcessed++;
@@ -485,4 +494,5 @@
     void appDomain_UnhandledException(object sender, UnhandledExceptionEventArgs e) {
       Logger.Error("Exception in AppDomain: " + e.ExceptionObject.ToString());
+      KillAppDomain(new Guid(e.ExceptionObject.ToString()));
     }
 
Index: branches/HeuristicLab.Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Slave.Core/3.3/HeuristicLab.Hive.Slave.Core-3.3.csproj
===================================================================
--- branches/HeuristicLab.Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Slave.Core/3.3/HeuristicLab.Hive.Slave.Core-3.3.csproj	(revision 4987)
+++ branches/HeuristicLab.Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Slave.Core/3.3/HeuristicLab.Hive.Slave.Core-3.3.csproj	(revision 5000)
@@ -86,5 +86,5 @@
     </Reference>
     <Reference Include="HeuristicLab.PluginInfrastructure-3.3">
-      <HintPath>C:\Program Files\HeuristicLab 3.3\HeuristicLab.PluginInfrastructure-3.3.dll</HintPath>
+      <HintPath>..\..\..\..\..\..\..\..\Program Files\HeuristicLab 3.3\HeuristicLab.PluginInfrastructure-3.3.dll</HintPath>
     </Reference>
     <Reference Include="System" />
Index: branches/HeuristicLab.Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Slave.Core/3.3/JobStorage/JobStorageManager.cs
===================================================================
--- branches/HeuristicLab.Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Slave.Core/3.3/JobStorage/JobStorageManager.cs	(revision 4987)
+++ branches/HeuristicLab.Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Slave.Core/3.3/JobStorage/JobStorageManager.cs	(revision 5000)
@@ -35,5 +35,5 @@
     private static List<JobStorageInfo> storedJobsList = new List<JobStorageInfo>();
 
-    private static String path = System.IO.Directory.GetCurrentDirectory() + "\\Hive.Slave.Jobs\\";
+    private static String path = Path.Combine(AppDomain.CurrentDomain.BaseDirectory, "Hive.Slave.Jobs");
 
     public static void PersistObjectToDisc(String serverIP, long serverPort, Guid jobId, byte[] job) {
@@ -43,5 +43,5 @@
       Stream jobstream = null;
       try {
-        jobstream = File.Create(path + filename + ".dat");
+        jobstream = File.Create(Path.Combine(path, filename + ".dat"));
         jobstream.Write(job, 0, job.Length);
         storedJobsList.Add(info);
@@ -64,5 +64,5 @@
         Logger.Info("Sending stored job " + storedJobsList[index - 1].JobID + " to the server");
         try {
-          byte[] job = File.ReadAllBytes(path + filename + ".dat");
+          byte[] job = File.ReadAllBytes(Path.Combine(path, filename + ".dat"));
           if (WcfService.Instance.IsJobStillNeeded(storedJobsList[index - 1].JobID).StatusMessage == ResponseStatus.Ok) {
             ResponseResultReceived res = WcfService.Instance.StoreFinishedJobResultsSync(ConfigManager.Instance.GetClientInfo().Id, storedJobsList[index - 1].JobID, job, TimeSpan.Zero, null, true); // unfortunately we do not have the correct ExecutionTime since we would need to unzip the job for that
@@ -71,5 +71,5 @@
           SlaveStatusInfo.JobsProcessed++;
           storedJobsList.Remove(storedJobsList[index - 1]);
-          File.Delete(path + filename + ".dat");
+          File.Delete(Path.Combine(path, filename + ".dat"));
         }
         catch (Exception e) {
Index: branches/HeuristicLab.Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Slave.Core/3.3/PluginCache.cs
===================================================================
--- branches/HeuristicLab.Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Slave.Core/3.3/PluginCache.cs	(revision 4987)
+++ branches/HeuristicLab.Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Slave.Core/3.3/PluginCache.cs	(revision 5000)
@@ -34,4 +34,6 @@
 namespace HeuristicLab.Hive.Slave.Core {
   public class PluginCache {
+    private static object locker = new object();
+    public const string ConfigFileName = "Sandbox.config";
 
     private static PluginCache instance = null;
@@ -52,8 +54,14 @@
     }
 
+    public string ConfigFilePath {
+      get {
+        return Path.Combine(PluginCacheDir, ConfigFileName);
+      }
+    }
+
     public PluginCache() {
       PluginCacheDir = Path.Combine(AppDomain.CurrentDomain.BaseDirectory, "PluginCache");
       PluginTempBaseDir = Path.Combine(AppDomain.CurrentDomain.BaseDirectory, "PluginTemp");
-      
+
       this.pm = new PluginManager(PluginCacheDir);
       DoUpdateRun();
@@ -70,81 +78,102 @@
     [MethodImpl(MethodImplOptions.Synchronized)]
     public void CopyPluginsForJob(List<HivePluginInfoDto> requests, Guid jobId) {
-      String targetDir = Path.Combine(PluginTempBaseDir, jobId.ToString());
-
-      if (Directory.Exists(targetDir)) {
-        Directory.Delete(targetDir, true);
-      }
-
-      DirectoryInfo di = Directory.CreateDirectory(targetDir);
-
-      foreach (HivePluginInfoDto requestedPlugin in requests) {
-        PluginDescription pd = cachedPlugins.Where(cp =>
-          cp.Name == requestedPlugin.Name &&
-          cp.Version.Major == requestedPlugin.Version.Major &&
-          cp.Version.Minor == requestedPlugin.Version.Minor &&
-          cp.Version.Revision == requestedPlugin.Version.Revision &&
-          cp.Version.MinorRevision >= requestedPlugin.Version.MinorRevision).
-          SingleOrDefault();
-        if (pd != null) {
-          foreach (IPluginFile ipf in pd.Files) {
-            File.Copy(ipf.Name, Path.Combine(targetDir, Path.GetFileName(ipf.Name)));
-          }
-        }
-      }
-
-      // copy files from PluginInfrastructure, which are not declared
-      string baseDir = Path.GetDirectoryName(Assembly.GetExecutingAssembly().Location);
-      File.Copy(Path.Combine(baseDir, "HeuristicLab.PluginInfrastructure-3.3.dll"), Path.Combine(targetDir, "HeuristicLab.PluginInfrastructure-3.3.dll"));
-      File.Copy(Path.Combine(baseDir, "ICSharpCode.SharpZipLib.dll"), Path.Combine(targetDir, "ICSharpCode.SharpZipLib.dll"));
-      File.Copy(Path.Combine(baseDir, "ICSharpCode.SharpZipLib License.txt"), Path.Combine(targetDir, "ICSharpCode.SharpZipLib License.txt"));
+      lock (locker) {
+        String targetDir = Path.Combine(PluginTempBaseDir, jobId.ToString());
+
+        if (Directory.Exists(targetDir)) {
+          Directory.Delete(targetDir, true);
+        }
+
+        DirectoryInfo di = Directory.CreateDirectory(targetDir);
+
+        foreach (HivePluginInfoDto requestedPlugin in requests) {
+          PluginDescription pd = cachedPlugins.Where(cp =>
+            cp.Name == requestedPlugin.Name &&
+            cp.Version.Major == requestedPlugin.Version.Major &&
+            cp.Version.Minor == requestedPlugin.Version.Minor).SingleOrDefault();
+          if (pd != null) {
+            foreach (IPluginFile ipf in pd.Files) {
+              File.Copy(ipf.Name, Path.Combine(targetDir, Path.GetFileName(ipf.Name)));
+            }
+          }
+        }
+
+        // copy config file
+        File.Copy(ConfigFilePath, Path.Combine(targetDir, ConfigFileName));
+
+        // copy files from PluginInfrastructure, which are not declared
+        string baseDir = Path.GetDirectoryName(Assembly.GetExecutingAssembly().Location);
+        CopyFile(baseDir, targetDir, "HeuristicLab.PluginInfrastructure-3.3.dll");
+        CopyFile(baseDir, targetDir, "ICSharpCode.SharpZipLib.dll");
+        CopyFile(baseDir, targetDir, "ICSharpCode.SharpZipLib License.txt");
+
+        // copy slave plugins, otherwise its not possible to register the UnhandledException handler to the appdomain
+        CopyFile(baseDir, targetDir, "HeuristicLab.Hive.Slave.Core-3.3.dll");
+        CopyFile(baseDir, targetDir, "HeuristicLab.Hive.Slave.Common-3.3.dll");
+        CopyFile(baseDir, targetDir, "HeuristicLab.Hive.Slave.Communication-3.3.dll");
+        CopyFile(baseDir, targetDir, "HeuristicLab.Hive.Slave.ExecutionEngine-3.3.dll");
+      }
+    }
+
+    private void CopyFile(string baseDir, string targetDir, string fileName) {
+      if (!File.Exists(Path.Combine(targetDir, fileName))) File.Copy(Path.Combine(baseDir, fileName), Path.Combine(targetDir, fileName));
     }
 
     [MethodImpl(MethodImplOptions.Synchronized)]
     internal void PreparePlugins(List<HivePluginInfoDto> requiredPlugins) {
-      Logger.Debug("Fetching plugins for job");
-      List<HivePluginInfoDto> localPlugins = new List<HivePluginInfoDto>();
-      List<HivePluginInfoDto> neededPlugins = new List<HivePluginInfoDto>();
-      List<HivePluginInfoDto> missingPlugins = new List<HivePluginInfoDto>();
-      bool found = false;
-
-      foreach (HivePluginInfoDto info in requiredPlugins) {
-        //we MAY run in problems here - if there is a plugin twice in requests, there may be added two different versions of the plugin
-        foreach (PluginDescription cachedPlugin in cachedPlugins) {
-          if (info.Name == cachedPlugin.Name && info.Version == cachedPlugin.Version) {
-            Logger.Debug("Found plugin " + info.Name + ", " + info.Version);
-            localPlugins.Add(new HivePluginInfoDto() { Id = new Guid(), Name = info.Name, Version = info.Version, Update = true });
-            neededPlugins.Add(info);
-            found = true;
-
-            break;
-          }
-        }
-        if (!found) {
-          Logger.Debug("Plugin NOT found " + info.Name + ", " + info.Version);
-          missingPlugins.Add(info);
-        }
-        found = false;
-      }
-
-      Logger.Debug("First run - Update the plugins in the cache");
-      localPlugins.AddRange(missingPlugins);
-      IEnumerable<CachedHivePluginInfoDto> updateablePlugins = WcfService.Instance.RequestPlugins(missingPlugins);
-
-      foreach (CachedHivePluginInfoDto updateablePlugin in updateablePlugins) {
-        PluginDescription pd = cachedPlugins.Where(cachedPlugin => cachedPlugin.Name == updateablePlugin.Name && cachedPlugin.Version == updateablePlugin.Version).SingleOrDefault();
-
-        if (pd != null) {
-          foreach (IPluginFile ipf in pd.Files) {
-            Logger.Debug(string.Format("deleting {0}", Path.GetFileName(ipf.Name)));
-            File.Delete(ipf.Name);
-          }
-        }
-
-        foreach (HivePluginFile pf in updateablePlugin.PluginFiles) {
-          Logger.Debug(string.Format("writing {0}", Path.GetFileName(pf.Name)));
-          File.WriteAllBytes(Path.Combine(PluginCacheDir, Path.GetFileName(pf.Name)), pf.BinaryFile);
-        }
-      }
-      DoUpdateRun();
+      lock (locker) {
+        Logger.Debug("Fetching plugins for job");
+        List<HivePluginInfoDto> localPlugins = new List<HivePluginInfoDto>();
+        List<HivePluginInfoDto> neededPlugins = new List<HivePluginInfoDto>();
+        List<HivePluginInfoDto> missingPlugins = new List<HivePluginInfoDto>();
+        bool found = false;
+
+        foreach (HivePluginInfoDto info in requiredPlugins) {
+          //we MAY run in problems here - if there is a plugin twice in requests, there may be added two different versions of the plugin
+          foreach (PluginDescription cachedPlugin in cachedPlugins) {
+            if (info.Name == cachedPlugin.Name && info.Version == cachedPlugin.Version) {
+              localPlugins.Add(new HivePluginInfoDto() { Id = new Guid(), Name = info.Name, Version = info.Version, Update = true });
+              neededPlugins.Add(info);
+              found = true;
+
+              break;
+            }
+          }
+          if (!found) {
+            Logger.Debug("Plugin NOT found " + info.Name + ", " + info.Version);
+            missingPlugins.Add(info);
+          }
+          found = false;
+        }
+
+        Logger.Debug("First run - Update the plugins in the cache");
+        localPlugins.AddRange(missingPlugins);
+        IEnumerable<CachedHivePluginInfoDto> updateablePlugins = WcfService.Instance.RequestPlugins(missingPlugins);
+
+        foreach (CachedHivePluginInfoDto updateablePlugin in updateablePlugins) {
+          PluginDescription pd = cachedPlugins.Where(cachedPlugin =>
+            cachedPlugin.Name == updateablePlugin.Name &&
+            cachedPlugin.Version.Major == updateablePlugin.Version.Major &&
+            cachedPlugin.Version.Minor == updateablePlugin.Version.Major).SingleOrDefault();
+
+          if (pd != null) {
+            foreach (IPluginFile ipf in pd.Files) {
+              Logger.Debug(string.Format("deleting {0}", Path.GetFileName(ipf.Name)));
+              File.Delete(ipf.Name);
+            }
+          }
+
+          foreach (HivePluginFile pf in updateablePlugin.PluginFiles) {
+            Logger.Debug(string.Format("writing {0}", Path.GetFileName(pf.Name)));
+            File.WriteAllBytes(Path.Combine(PluginCacheDir, Path.GetFileName(pf.Name)), pf.BinaryFile);
+          }
+        }
+
+        // download config file
+        HivePluginFile configFile = WcfService.Instance.GetConfigurationFile();
+        File.WriteAllBytes(ConfigFilePath, configFile.BinaryFile);
+
+        DoUpdateRun();
+      }
     }
 
@@ -152,5 +181,16 @@
       try {
         Logger.Debug("unloading...");
-        Directory.Delete(Path.Combine(PluginTempBaseDir, id.ToString()), true);
+        int tries = 5;
+        while (tries > 0) {
+          try {
+            Directory.Delete(Path.Combine(PluginTempBaseDir, id.ToString()), true);
+            tries = 0;
+          }
+          catch {
+            Thread.Sleep(1000);
+            tries--;
+            if (tries == 0) throw;
+          }
+        }
       }
       catch (Exception ex) {
@@ -158,4 +198,6 @@
       }
     }
+
+
   }
 }
Index: branches/HeuristicLab.Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Slave.Core/3.3/Properties/Settings.Designer.cs
===================================================================
--- branches/HeuristicLab.Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Slave.Core/3.3/Properties/Settings.Designer.cs	(revision 4987)
+++ branches/HeuristicLab.Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Slave.Core/3.3/Properties/Settings.Designer.cs	(revision 5000)
@@ -26,16 +26,4 @@
         [global::System.Configuration.UserScopedSettingAttribute()]
         [global::System.Diagnostics.DebuggerNonUserCodeAttribute()]
-        [global::System.Configuration.DefaultSettingValueAttribute("")]
-        public string ServerIP {
-            get {
-                return ((string)(this["ServerIP"]));
-            }
-            set {
-                this["ServerIP"] = value;
-            }
-        }
-        
-        [global::System.Configuration.UserScopedSettingAttribute()]
-        [global::System.Diagnostics.DebuggerNonUserCodeAttribute()]
         [global::System.Configuration.DefaultSettingValueAttribute("00000000-0000-0000-0000-000000000000")]
         public global::System.Guid Guid {
Index: branches/HeuristicLab.Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Slave.Core/3.3/Properties/Settings.settings
===================================================================
--- branches/HeuristicLab.Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Slave.Core/3.3/Properties/Settings.settings	(revision 4987)
+++ branches/HeuristicLab.Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Slave.Core/3.3/Properties/Settings.settings	(revision 5000)
@@ -3,7 +3,4 @@
   <Profiles />
   <Settings>
-    <Setting Name="ServerIP" Type="System.String" Scope="User">
-      <Value Profile="(Default)" />
-    </Setting>
     <Setting Name="Guid" Type="System.Guid" Scope="User">
       <Value Profile="(Default)">00000000-0000-0000-0000-000000000000</Value>
Index: branches/HeuristicLab.Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Slave.Core/3.3/SlaveConsoleService/Interfaces/ISlaveConsoleCommunicator.cs
===================================================================
--- branches/HeuristicLab.Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Slave.Core/3.3/SlaveConsoleService/Interfaces/ISlaveConsoleCommunicator.cs	(revision 4987)
+++ branches/HeuristicLab.Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Slave.Core/3.3/SlaveConsoleService/Interfaces/ISlaveConsoleCommunicator.cs	(revision 5000)
@@ -37,21 +37,5 @@
     [OperationContract]
     StatusCommons GetStatusInfos();
-    /// <summary>
-    /// Set the connection settings in the wcfService
-    /// </summary>
-    /// <param name="container">the container with the connection details</param>
-    [OperationContract]
-    void SetConnection(ConnectionContainer container);
-    /// <summary>
-    /// Signals the client to disconnect from the server
-    /// </summary>
-    //[OperationContract]
-    //void Disconnect();
-    /// <summary>
-    /// Get the current connection details
-    /// </summary>
-    /// <returns>the ConnectionContainer Object</returns>
-    [OperationContract]
-    ConnectionContainer GetCurrentConnection();
+
     /// <summary>
     /// Signals the client to exit all jobs and shutdown
Index: branches/HeuristicLab.Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Slave.Core/3.3/SlaveConsoleService/SlaveConsoleCommunicator.cs
===================================================================
--- branches/HeuristicLab.Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Slave.Core/3.3/SlaveConsoleService/SlaveConsoleCommunicator.cs	(revision 4987)
+++ branches/HeuristicLab.Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Slave.Core/3.3/SlaveConsoleService/SlaveConsoleCommunicator.cs	(revision 5000)
@@ -39,12 +39,4 @@
     }
 
-    public void SetConnection(ConnectionContainer container) {
-      ConfigManager.Instance.SetServerIP(container);
-    }
-
-    public ConnectionContainer GetCurrentConnection() {
-      return new ConnectionContainer();
-    }
-
     public void ShutdownClient() {
       MessageQueue.GetInstance().AddMessage(MessageContainer.MessageType.Shutdown);
Index: branches/HeuristicLab.Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Slave.ExecutionEngine/3.3/Executor.cs
===================================================================
--- branches/HeuristicLab.Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Slave.ExecutionEngine/3.3/Executor.cs	(revision 4987)
+++ branches/HeuristicLab.Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Slave.ExecutionEngine/3.3/Executor.cs	(revision 5000)
@@ -29,4 +29,5 @@
 using HeuristicLab.Hive.Slave.Common;
 using HeuristicLab.Persistence.Core;
+using System.Threading;
 
 namespace HeuristicLab.Hive.Slave.ExecutionEngine {
@@ -47,5 +48,5 @@
     }
     public MessageQueue Queue { get; set; }
-    
+
     public ExecutionState ExecutionState {
       get {
@@ -62,7 +63,4 @@
     public DateTime CreationTime { get; set; }
 
-    /// <summary>
-    /// 
-    /// </summary>
     /// <param name="serializedJob"></param>
     /// <param name="collectChildJobs">if true, all child-jobs are downloaded and the job will be resumed.</param>
@@ -198,4 +196,9 @@
 
       if (Job.ExecutionState == Core.ExecutionState.Started) {
+        try { Job.Stop(); }
+        catch { }
+      }
+
+      if (Job.ExecutionState == Core.ExecutionState.Started) {
         throw new InvalidStateException("Job is still running"); //Job isn't finished!
       } else {
@@ -223,5 +226,5 @@
 
     public void Dispose() {
-      if(Job != null)
+      if (Job != null)
         DeregisterJobEvents();
       Queue = null;
